function [ diag_prod ] = diag_of_prod( A_val, A_row_ind , A_col_ptr, M_val, M_row_ind , M_col_ptr )
%diag_of_prod Determines diagonal of the product of the two matrices
%   A_val Values of matrix A up-bottom and left-right (1. colum up to
%   bottom, then 2. column up to bottom, ...)
%   A_row_ind Row indices of the matrix A
%   A_col_ptr Pointer on the columns of A
%   Rest Same for matrix M (CCS-format)

%Example: [a,b,c]=find(sparse(A)); [a2,b2,c2]=find(sparse(M));
%c=A_val, a=A_row_ind, b is col_ptr but instead of [1,1,2,2,3,4] we need
%[1,3,5,6,7]. I.e. delete double values but remember position in vector and
%add one pointer to the position length(b)+1.

n=length(A_col_ptr)-1;
diag_prod_M_A=zeros(1,n);


k_A=0;			%Diagonalcounter fr Matrix A
for i=1:length(A_col_ptr)-1
	k_A=k_A+1;
	for j=A_col_ptr(i):A_col_ptr(i+1)-1
        if A_row_ind(j)>k_A
            break;
        elseif A_row_ind(j)==k_A
			diag_val_A=A_val(j);
            k_M=0;          %Diagonalcounter fr Matrix M
			for l=1:k_A
				k_M=k_M+1;
				if k_M==k_A
					for ll=M_col_ptr(l):M_col_ptr(l+1)-1
						if M_row_ind(ll)>k_A
                            break;
                        elseif M_row_ind(ll)==k_A
							diag_val_M=M_val(ll);
							diag_prod_M_A(k_A)=diag_val_M*diag_val_A;
							break;
						end
					break;
					end
				end
            end
		end
	end
end

vec=1:n;

diag_prod=sparse(vec,vec,diag_prod_M_A,n,n);


end