function M = sai_IisJ(A, P, E)
%SAI_IisJ SAI-Preconditioner with I=J
% A matrix of system Ax=b, to be preconditioned
% P pattern of preconditioner M
% E goalmatrix   min ||AM-E||

if nargin < 3
   E = speye(size(A)); 
end

n = size(A,1);
M = sparse(n,n);

% for each column
for k=1:n
    
    % compute column M_k for given pattern
    J_k = find(P(:,k));
    e_k = E(J_k,k);
    M(J_k,k) = A(J_k, J_k) \ e_k;

end
end
