/*
    ======================================================================
    ======================================================================
    ==                                                                  ==
    ==  MSPAI:  Modified SPAI algorithm to comupte SParse Approximate   ==
    ==          Invers matrices.                                        ==
    ==                                                                  ==
    ==  Copyright (C)  2007, 2008, 2009 by                              ==
    ==                 Matous Sedlacek <sedlacek@in.tum.de>             ==
    ==                 Chair of Scientific Computing -- Informatics V   ==
    ==                 Technische Universität München                   ==
    ==                                                                  ==
    ==  This file is part of MSPAI.                                     ==
    ==                                                                  ==
    ==  MSPAI is free software: you can redistribute it and/or          ==
    ==  modify it under the terms of the GNU Lesser General Public      ==
    ==  License as published by the Free Software Foundation, either    ==
    ==  version 3 of the License, or (at your option) any later version.==
    ==                                                                  ==
    ==  MSPAI is distributed in the hope that it will be useful,        ==
    ==  but WITHOUT ANY WARRANTY; without even the implied warranty of  ==
    ==  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   ==
    ==  GNU Lesser General Public License for more details.             ==
    ==                                                                  ==
    ==  You should have received a copy of the GNU Lesser General       ==
    ==  Public License along with MSPAI.                                ==
    ==  If not, see <http://www.gnu.org/licenses/>.                     ==
    ==                                                                  ==
    ======================================================================
    ======================================================================
*/


#ifndef GUARD_MATRIX_BASIS_H
#define GUARD_MATRIX_BASIS_H


//////////////////////////////////////
///     \class Matrix_Base
///     \brief Base class of Matrix
//////////////////////////////////////
class Matrix_Base
{
    
    public:
        
        /// The pe's Id within MPI environment
        int     my_id;
        
        /// The number of pe's within MPI environment
        int     num_procs;
        
        /// The number of columns to solve by this pe
        int     my_nbr_cols;
                       
        /// The start index of the first column to solve
        /// within whole input matrix
        int     my_start_index;

        /// Number of columns
        int     n;    
        
        /// Number of rows
        int     m;

        /// my_nbr_cols of each pe
        int     *all_nbr_cols;
        
        /// my_start_index of each pe
        int     *start_indices; 
        
        /// nnz in this pe
        int     my_nnz;        
        
        /// processor assignment for every row 
        /// and column
        int     *pe;   
                
        /// Whether the matrix is symmetric 
        /// or not
        bool    symmetric;
};

#endif
